#include <ansi_c.h>
#include "sqlite3.h"
#include "CVI Interface for SQLite.h"


//Structure to hold all pertenant information from the SQLite DB.
struct LV_SQLite_Structure {
	sqlite3			* DBReference;
	sqlite3_stmt	* userquery;
};


//Global DB Structure Reference.
struct LV_SQLite_Structure*			Current_SQLite_DB;


int OpenSQLiteDB(char* filename, int *SQL_Structure)
{
	int			sqlerror;

	
	Current_SQLite_DB = (struct LV_SQLite_Structure *)malloc(sizeof(struct LV_SQLite_Structure));
	

	sqlerror = sqlite3_open(filename, &Current_SQLite_DB->DBReference);
	
	*SQL_Structure = (int)Current_SQLite_DB;
	
	return sqlerror;
}

int CloseSQLiteDB(int SQL_Structure)
{
	int sqlerror;
	
	if(!Current_SQLite_DB)
		return 0;
	
	Current_SQLite_DB = (struct LV_SQLite_Structure *)SQL_Structure;
	
	sqlerror = sqlite3_finalize(Current_SQLite_DB->userquery);
	
	if(sqlerror == 21)
		return (sqlerror);
	
	sqlerror = sqlite3_close(Current_SQLite_DB->DBReference);
	
	free(Current_SQLite_DB);
	
	return sqlerror;
}


int ExecuteSQLStatement(int SQL_Structure, char* sqlstatement, int* columncount, char* columntypes)
{
	int	sqlerror;
	int	i;
	
	Current_SQLite_DB = (struct LV_SQLite_Structure *)SQL_Structure;
	
	sqlerror = sqlite3_prepare(Current_SQLite_DB->DBReference, sqlstatement, strlen(sqlstatement), &Current_SQLite_DB->userquery, NULL);
	
	if(sqlerror)
		return (sqlerror);
	
	sqlerror = sqlite3_step(Current_SQLite_DB->userquery);
	
	*columncount = sqlite3_column_count(Current_SQLite_DB->userquery);
	
	for(i = 0; i<*columncount; i++)
	{
		if(i == 0)
		{
			sprintf(columntypes, "%s", sqlite3_column_decltype(Current_SQLite_DB->userquery, i));
		}
		else
		{
			sprintf(columntypes, "%s,%s", columntypes, sqlite3_column_decltype(Current_SQLite_DB->userquery, i));
		}
	}
	
	
	
	return sqlerror;
}

int StepSQLStatement(int SQL_Structure)
{
	int	sqlerror;
	
	Current_SQLite_DB = (struct LV_SQLite_Structure *)SQL_Structure;
	
	//sqlerror = sqlite3_prepare(Current_SQLite_DB->DBReference, sqlstatement, strlen(sqlstatement), &Current_SQLite_DB->userquery, NULL);
	
	//if(sqlerror)
	//	return (sqlerror);
	
	sqlerror = sqlite3_step(Current_SQLite_DB->userquery);
	
	
	return sqlerror;
}

int RetrieveIntegerData(int SQL_Structure, int column, int* rowinteger)
{
	int sqlerror;

	Current_SQLite_DB = (struct LV_SQLite_Structure *)SQL_Structure;
	
	*rowinteger = sqlite3_column_int(Current_SQLite_DB->userquery, column);
	
	sqlerror = sqlite3_errcode(Current_SQLite_DB->DBReference);
	
	return sqlerror;
}

int RetrieveTextData(int SQL_Structure, int column, char* rowtext)
{
	int sqlerror;
	const unsigned char *	temptext;
	
	Current_SQLite_DB = (struct LV_SQLite_Structure *)SQL_Structure;
	
	temptext = sqlite3_column_text(Current_SQLite_DB->userquery, column);
	if(temptext)
		sprintf(rowtext, "%s", temptext);
		
	
	sqlerror = sqlite3_errcode(Current_SQLite_DB->DBReference);
	
	return sqlerror;
}

int RetrieveDoubleData(int SQL_Structure, int column, double* rowdouble)
{
	int sqlerror;
	
	Current_SQLite_DB = (struct LV_SQLite_Structure *)SQL_Structure;
	
	*rowdouble = sqlite3_column_double(Current_SQLite_DB->userquery, column);
	
	sqlerror = sqlite3_errcode(Current_SQLite_DB->DBReference);
	
	return sqlerror;
}

int ReleaseData(int SQL_Structure)
{
	int	sqlerror;

	Current_SQLite_DB = (struct LV_SQLite_Structure *)SQL_Structure;
	
	sqlerror = sqlite3_reset(Current_SQLite_DB->userquery);
	
	return sqlerror;
}
